=== debian/changelog ===
zmap (4.3.4-1) unstable; urgency=medium

  [ Phillip Stephens]
  * New maintainer
    Closes: #1104555
  * New upstream version
    Closes: #1107250, #1045201
  * Update Build-Depends

  [ Andreas Tille ]
  * Point Vcs fields to Salsa
  * Fix watch file
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Phillip Stephens <phillip@cs.stanford.edu>  Sat, 28 Jun 2025 07:40:55 +0200

zmap (2.1.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/p/fix-build-with-json-c-0.14.patch: Fix FTBFS with libjson-c.
    (Closes: #1058349)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Tue, 23 Jan 2024 15:33:37 -0500
