=== debian/control ===
Source: zmap
Maintainer: Phillip Stephens <phillip@cs.stanford.edu>
Uploaders: Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>
Section: net
Priority: optional
Build-Depends: byacc,
               cmake,
               debhelper-compat (= 13),
               flex,
               gengetopt,
               libgmp3-dev,
               libjson-c-dev,
               libpcap-dev,
               libunistring-dev,
               libjudy-dev,
               pkgconf
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/zmap
Vcs-Git: https://salsa.debian.org/debian/zmap.git
Homepage: https://zmap.io/

Package: zmap
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: network scanner for researchers
 ZMap is a network scanner that enables researchers to
 easily perform Internet-wide network studies. With a single
 machine and a well provisioned network uplink, ZMap is capable of
 performing a complete scan of the IPv4 address space in under 45
 minutes, approaching the theoretical limit of gigabit Ethernet.
 .
 ZMap can be used to study protocol adoption over time, monitor
 service availability, and help people better understand large systems
 distributed across the Internet.
